﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using OrderService.Infrastructure;

#nullable disable

namespace OrderService.DataAccess.Postgre.Migrations
{
    [DbContext(typeof(OrderContext))]
    [Migration("20240515102756_Initial migration")]
    partial class Initialmigration
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasDefaultSchema("order")
                .HasAnnotation("ProductVersion", "8.0.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("OrderService.Entities.Order", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid>("CategoryId")
                        .HasColumnType("uuid");

                    b.Property<DateTime>("Created")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("DueDate")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<decimal>("Price")
                        .HasColumnType("numeric");

                    b.Property<int>("Status")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.HasIndex("CategoryId");

                    b.ToTable("Orders", "order");
                });

            modelBuilder.Entity("OrderService.Entities.OrderProposal", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<Guid>("OrderId")
                        .HasColumnType("uuid");

                    b.Property<int>("Status")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.HasIndex("OrderId");

                    b.ToTable("OrderProposal", "order");
                });

            modelBuilder.Entity("OrderService.Entities.OrderCategory", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<Guid?>("ParentId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("ParentId")
                        .IsUnique();

                    b.ToTable("OrderCategory", "order");
                });

            modelBuilder.Entity("OrderService.Entities.OrderExecutor", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<Guid>("OrderId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("OrderId");

                    b.ToTable("OrderExecutor", "order");
                });

            modelBuilder.Entity("OrderService.Entities.OrderFile", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<Guid>("OrderId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("OrderId");

                    b.ToTable("OrderFile", "order");
                });

            modelBuilder.Entity("OrderService.Entities.Order", b =>
                {
                    b.HasOne("OrderService.Entities.OrderCategory", "OrderCategory")
                        .WithMany("Order")
                        .HasForeignKey("CategoryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.OwnsOne("OrderService.Entities.UserRef", "CustomerRef", b1 =>
                        {
                            b1.Property<Guid>("OrderId")
                                .HasColumnType("uuid");

                            b1.Property<Guid>("UserId")
                                .HasColumnType("uuid");

                            b1.Property<string>("UserNmae")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderId");

                            b1.ToTable("Orders", "order");

                            b1.ToJson("CustomerRef");

                            b1.WithOwner()
                                .HasForeignKey("OrderId");
                        });

                    b.OwnsMany("OrderService.Entities.TimeStamp", "TimeStamp", b1 =>
                        {
                            b1.Property<Guid>("OrderId")
                                .HasColumnType("uuid");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("integer");

                            b1.Property<int>("Change")
                                .HasColumnType("integer");

                            b1.Property<DateTimeOffset>("ChangeTime")
                                .HasColumnType("timestamp with time zone");

                            b1.Property<string>("Initiator")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderId", "Id");

                            b1.ToTable("Orders", "order");

                            b1.ToJson("TimeStamp");

                            b1.WithOwner()
                                .HasForeignKey("OrderId");
                        });

                    b.Navigation("CustomerRef")
                        .IsRequired();

                    b.Navigation("OrderCategory");

                    b.Navigation("TimeStamp");
                });

            modelBuilder.Entity("OrderService.Entities.OrderProposal", b =>
                {
                    b.HasOne("OrderService.Entities.Order", "Order")
                        .WithMany("OrderProposal")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.NoAction)
                        .IsRequired();

                    b.OwnsOne("OrderService.Entities.UserRef", "DeveloperRef", b1 =>
                        {
                            b1.Property<Guid>("OrderProposalId")
                                .HasColumnType("uuid");

                            b1.Property<Guid>("UserId")
                                .HasColumnType("uuid");

                            b1.Property<string>("UserNmae")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderProposalId");

                            b1.ToTable("OrderProposal", "order");

                            b1.ToJson("DeveloperRef");

                            b1.WithOwner()
                                .HasForeignKey("OrderProposalId");
                        });

                    b.OwnsMany("OrderService.Entities.TimeStamp", "TimeStamp", b1 =>
                        {
                            b1.Property<Guid>("OrderProposalId")
                                .HasColumnType("uuid");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("integer");

                            b1.Property<int>("Change")
                                .HasColumnType("integer");

                            b1.Property<DateTimeOffset>("ChangeTime")
                                .HasColumnType("timestamp with time zone");

                            b1.Property<string>("Initiator")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderProposalId", "Id");

                            b1.ToTable("OrderProposal", "order");

                            b1.ToJson("TimeStamp");

                            b1.WithOwner()
                                .HasForeignKey("OrderProposalId");
                        });

                    b.Navigation("DeveloperRef")
                        .IsRequired();

                    b.Navigation("Order");

                    b.Navigation("TimeStamp");
                });

            modelBuilder.Entity("OrderService.Entities.OrderCategory", b =>
                {
                    b.HasOne("OrderService.Entities.OrderCategory", "Parent")
                        .WithOne()
                        .HasForeignKey("OrderService.Entities.OrderCategory", "ParentId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.OwnsMany("OrderService.Entities.TimeStamp", "TimeStamp", b1 =>
                        {
                            b1.Property<Guid>("OrderCategoryId")
                                .HasColumnType("uuid");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("integer");

                            b1.Property<int>("Change")
                                .HasColumnType("integer");

                            b1.Property<DateTimeOffset>("ChangeTime")
                                .HasColumnType("timestamp with time zone");

                            b1.Property<string>("Initiator")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderCategoryId", "Id");

                            b1.ToTable("OrderCategory", "order");

                            b1.ToJson("TimeStamp");

                            b1.WithOwner()
                                .HasForeignKey("OrderCategoryId");
                        });

                    b.Navigation("Parent");

                    b.Navigation("TimeStamp");
                });

            modelBuilder.Entity("OrderService.Entities.OrderExecutor", b =>
                {
                    b.HasOne("OrderService.Entities.Order", "Order")
                        .WithMany("OrderExecutor")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.NoAction)
                        .IsRequired();

                    b.OwnsOne("OrderService.Entities.UserRef", "ExecutorRef", b1 =>
                        {
                            b1.Property<Guid>("OrderExecutorId")
                                .HasColumnType("uuid");

                            b1.Property<Guid>("UserId")
                                .HasColumnType("uuid");

                            b1.Property<string>("UserNmae")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderExecutorId");

                            b1.ToTable("OrderExecutor", "order");

                            b1.ToJson("ExecutorRef");

                            b1.WithOwner()
                                .HasForeignKey("OrderExecutorId");
                        });

                    b.OwnsMany("OrderService.Entities.TimeStamp", "TimeStamp", b1 =>
                        {
                            b1.Property<Guid>("OrderExecutorId")
                                .HasColumnType("uuid");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("integer");

                            b1.Property<int>("Change")
                                .HasColumnType("integer");

                            b1.Property<DateTimeOffset>("ChangeTime")
                                .HasColumnType("timestamp with time zone");

                            b1.Property<string>("Initiator")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderExecutorId", "Id");

                            b1.ToTable("OrderExecutor", "order");

                            b1.ToJson("TimeStamp");

                            b1.WithOwner()
                                .HasForeignKey("OrderExecutorId");
                        });

                    b.Navigation("ExecutorRef")
                        .IsRequired();

                    b.Navigation("Order");

                    b.Navigation("TimeStamp");
                });

            modelBuilder.Entity("OrderService.Entities.OrderFile", b =>
                {
                    b.HasOne("OrderService.Entities.Order", "Order")
                        .WithMany("OrderFile")
                        .HasForeignKey("OrderId")
                        .OnDelete(DeleteBehavior.NoAction)
                        .IsRequired();

                    b.OwnsMany("OrderService.Entities.TimeStamp", "TimeStamp", b1 =>
                        {
                            b1.Property<int>("OrderFileId")
                                .HasColumnType("integer");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("integer");

                            b1.Property<int>("Change")
                                .HasColumnType("integer");

                            b1.Property<DateTimeOffset>("ChangeTime")
                                .HasColumnType("timestamp with time zone");

                            b1.Property<string>("Initiator")
                                .IsRequired()
                                .HasColumnType("text");

                            b1.HasKey("OrderFileId", "Id");

                            b1.ToTable("OrderFile", "order");

                            b1.ToJson("TimeStamp");

                            b1.WithOwner()
                                .HasForeignKey("OrderFileId");
                        });

                    b.Navigation("Order");

                    b.Navigation("TimeStamp");
                });

            modelBuilder.Entity("OrderService.Entities.Order", b =>
                {
                    b.Navigation("OrderProposal");

                    b.Navigation("OrderExecutor");

                    b.Navigation("OrderFile");
                });

            modelBuilder.Entity("OrderService.Entities.OrderCategory", b =>
                {
                    b.Navigation("Order");
                });
#pragma warning restore 612, 618
        }
    }
}
